
/**
  *
  *  Computer Networks Course
  *  PA0 Included Content
  *
  *  Main Graphics Header
  *
  *  Author: Kamyar Allahverdi
  *
  */

#ifndef __PA0_GRAPHICS__
#define __PA0_GRAPHICS__

#include "map.h"
#include "log.h"

TextureImage fortress,soldier,forest,concrete;

void init()
{
	if (!LoadTGA(&fortress,"icons/fortress.tga") ||
		!LoadTGA(&soldier,"icons/soldier.tga") ||
		!LoadTGA(&concrete,"icons/concrete.tga") ||
		!LoadTGA(&forest,"icons/grass.tga"))
	{
		exit(1);
	}

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	//background color
	glClearColor(0.9, 0.9, 0.9, 1.0f);
	//glClearColor(1, 1, 1, 1.0f);
	glOrtho(0.0, SCREEN_WIDTH+SIDEBAR_WIDTH, SCREEN_HEIGHT, 0.0f, 0.0f, 1.0f);

}

void startGraphics(draw_func funcptr,mouse_func mouseptr,keyboard_func keyboardptr)
{
	int c=0;
	glutInit(&c,NULL);
	glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);  
	glutInitWindowSize(SCREEN_WIDTH+SIDEBAR_WIDTH,SCREEN_HEIGHT);
	glutInitWindowPosition(0,0); 
	glutCreateWindow("PA0 - Tower Defense"); 
	glutDisplayFunc(funcptr);
	/* in case of problem with redrawing uncomment below */
// 	glutIdleFunc(funcptr);
	glutMouseFunc(mouseptr);
	glutKeyboardFunc(keyboardptr);
	init();
	glutMainLoop();
}

#endif
