
/**
  *
  *  Computer Networks Course
  *  PA0 Included Content
  *
  *  Sample Graphical Interface
  *
  *  Author: Kamyar Allahverdi
  *
  */


#include "graphics.h"
#include "log.h"

using std::endl;

void mouse(int button, int state, int x, int y)
{
	if (button==GLUT_LEFT && state==GLUT_DOWN)
	{
		LOG << "Mouse left button clicked at (" << x << "," << y << ")" << endl;
	}
}

void keyboard(unsigned char key, int x,int y)
{
	if(key == 'k')
	{
		LOG << "K has been pressed" << endl;
	}
	else if(key == 13)
	{
		DEBUG << "Enter has been pressed" << endl;
	}
}

void draw(void)
{
	// clear the background to the color specified with glClearColor
	// see init() in graphics.h
	glClear(GL_COLOR_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	
	//save position
	glPushMatrix();

	glLineWidth( 2.f );
	glColor3f(0,1,0);
	glprint(SCREEN_WIDTH+ 7,25,"Hello Graphics!");

	int rows = 10;
	int cols = 10;

	// change color to white
	// to blend texture with another color use colors other than white
	glColor3f(1,1,1);
	for(int k=0;k<rows;k++)
	{
		for(int i=0;i<cols;i++)
		{
			// bind the texture that we want to use
			glBindTexture(GL_TEXTURE_2D, forest.texID);

			// draw a square with the specified width
			draw_cell(SCREEN_WIDTH/cols);

			// move, relatively, about one cell to right
			glTranslatef(SCREEN_WIDTH/cols,0,0);
		}
		// move, relatively, about the screen width to the left of screen
		glTranslatef(-SCREEN_WIDTH,SCREEN_WIDTH/rows,0);
	}
	// revert position to what it was before
	glPopMatrix();

	// begin drawing what we drawed so far
	glFlush();
}

int main(int argc, char** argv)
{

	/*
	 * Create extra threads here
	 */

	//blocking
	startGraphics(draw,mouse,keyboard);
}
